KTextEditor::TemplateInterface Class Referenceabstract

`#include <templateinterface.h>`

## Public Member Functions

uint | templateInterfaceNumber () const
bool | insertTemplateText (uint line, uint column, const QString &templateString, const QMap< QString, QString > &initialValues, QWidget *parentWindow=0)

## Static Public Member Functions

static bool | expandMacros (QMap< QString, QString > &initialValues, QWidget *parentWindow)

## Protected Member Functions

void | setTemplateInterfaceDCOPSuffix (const QCString &suffix)
virtual bool | insertTemplateTextImplementation (uint line, uint column, const QString &templateString, const QMap< QString, QString > &initialValues, QWidget *parentWindow=0)=0

## Friends

class | PrivateTemplateInterface

## Detailed Description

This is an interface for inserting template strings with user editable fields into a document.

Definition at line 37 of file templateinterface.h.

## Member Function Documentation

bool TemplateInterface::expandMacros | ( | QMap< QString, QString > & | initialValues,
|  | QWidget * | parentWindow
| ) |  |

static

Parses `templateString` for macros in the form [$%]{NAME} and finds the value corresponding to NAME if any.

The NAME string may contain any non-whitespace character execpt '}'

Parameters

  initialValues | a map with the keys for the macros to expand. keys with a value are ignored.
  parentWindow | is used if dialogs have to be shown

Returns
  true if all macros was sucessfully expanded

See also
  insertTemplateText for a list of supported macros

Definition at line 73 of file templateinterface.cpp.

bool TemplateInterface::insertTemplateText | ( | uint | line,
|  | uint | column,
|  | const QString & | templateString,
|  | const QMap< QString, QString > & | initialValues,
|  | QWidget * | parentWindow = `0`
| ) |  |

Inserts an interactive ediable template text at line "line", column "col".

`parentWindow` is used if dialogs have to be shown

Returns
  true if inserting the string succeeded

Use insertTemplateText(numLines(), ...) to append text at end of document Template strings look like "for( int ${index}=0;${index}<10;${index}++) { ${cursor} };" or "%{date}"

This syntax is somewhat similiar to the one found in the Eclipse editor.

There are certain common placeholders (macros), which get assigned a default initialValue, If the second parameter does not a given value. For all others the initial value is the name of the placeholder.

Placeholder names may only consist of a-zA-Z0-9_ Common placeholders and values are

- index: "i"
- loginname: The current users's loginname
- firstname: The current user's first name retrieved from kabc
- lastname: The current user's last name retrieved from kabc
- fullname: The current user's first and last name retrieved from kabc
- email: The current user's primary email adress retrieved from kabc
- date: current date
- time: current time
- year: current year
- month: current month
- day: current day
- hostname: hostname of the computer
- cursor: at this position the cursor will be after editing of the template has finished, this has to be taken care of by the actual implementation. The placeholder gets a value of "|" assigned.

If a macro is started with a % (persent sign) like "%{date}" it isn't added to the list editable strings ( for example TAB key navigation) if a value differing from the macro name is found.

If the editor supports some kind of smart indentation, the inserted code should be layouted by the indenter.

Definition at line 152 of file templateinterface.cpp.

virtual bool KTextEditor::TemplateInterface::insertTemplateTextImplementation | ( | uint | line,
|  | uint | column,
|  | const QString & | templateString,
|  | const QMap< QString, QString > & | initialValues,
|  | QWidget * | parentWindow = `0`
| ) |  |

protected pure virtual

You must implement this, it is called by insertTemplateText, after all default values are inserted.

If you are implementing this interface, this method should work as described in the documentation for insertTemplateText above.

Returns
  true if any text was inserted.

The documentation for this class was generated from the following files:

- templateinterface.h
- templateinterface.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys